#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <limits>
#include <cmath>
#include <cstdio>
#include <vector>
#include <queue>

#define DEBUG

#ifdef DEBUG
	#define DBG if (1)
#else
	#define DBG if (0)
#endif

#define PA(arr, n) DBG for (int i = 0; i < n; i++) printf("%d%c", arr[i], "\n "[i < n - 1])
#define PD(n) DBG printf("DEBUG %d\n", n); 
#define PDBL(n) DBG printf("%lf\n", n);

using namespace std;

int maxim(int time, int k, vector<int> &arr){

		int sum = 0, m = 0;
		for(int i = 0; i < (int)arr.size(); i++){
			int a = arr[i] - (time*k + sum);
			sum = -a;
			PD(a);
			m = (a>m)? a:m;
			PD(m);
		}
PD(m);
return m;
}

int minim(int time, int k, vector<int> &arr){

		int sum = 0, m = 0;
		for(int i = 0; i < (int)arr.size(); i++){
			int a = arr[i] - (time*k + sum);
			sum = -a;
			m = min(m,a);
		}
return m;
}

bool OK(int time, int k, vector<int> &arr){
	int sum = 0;
	for(int i = 0; i < (int)arr.size(); i++){
		int a = arr[i] - (time*k + sum);
		if(a<=0)
			sum = -a;
		else return 0;
	}
	return 1;
}

int main () {

	int n, f;
	while(scanf("%d %d", &n, &f) == 2){
		vector<int> arr(n, 0); int m = 0;
		for (int i = 0; i < n; i++){
			scanf("%d", &arr[i]);
			m = max(m,arr[i]);
		}	
		int lo = -1, hi = m/f+1, mid;
		while(hi-lo > 1){
			mid = (hi+lo)/2;
			if(OK(mid,f,arr))
				hi = mid;
			else
				lo = mid;		
		}
		int a = maxim(lo, f, arr);
		int b = minim(hi, f, arr);
		PD(a);
		PD(b);
		int c = a-b;
		PD(c);
		PDBL((double)(hi-1)/(double)f);
		printf("%lf\n", (double)(hi)/(double)f+(double)a/(double)c);


	}

	return 0;

}
